
/**
Stellt eine Dame auf der Grafikoberfläche dar.
- author: Albert Wiedemann
- version: 1.0
 */
class Dame
{
    /** x-Position der Dame */
    private var x: Int
    /** y-Position der Dame */
    private var y: Int
    /** Das Basisrechteck */
    private let basis: Rechteck
    /** 1. Zacke der Krone */
    private let zacke1: Dreieck
    /** 2. Zacke der Krone */
    private let zacke2: Dreieck
    /** 3. Zacke der Krone */
    private let zacke3: Dreieck
    /** 4. Zacke der Krone */
    private let zacke4: Dreieck
    /** Kreis auf der 1. Zacke */
    private let kreis1: Kreis
    /** Kreis auf der 2. Zacke */
    private let kreis2: Kreis
    /** Kreis auf der 3. Zacke */
    private let kreis3: Kreis
    /** Kreis auf der 4. Zacke */
    private let kreis4: Kreis

    /**
    Erzeugt die Einzelteile der Dame
    */
    init()
    {
        x = 50
        y = 50
        basis = Rechteck()
        basis.FarbeSetzen(farbe: "orange")
        basis.GrößeSetzen(breite: 40, höhe: 10)
        zacke1 = Dreieck()
        zacke1.FarbeSetzen(farbe: "orange")
        zacke1.GrößeSetzen(breite: 10, höhe: 20)
        zacke2 = Dreieck()
        zacke2.FarbeSetzen(farbe: "orange")
        zacke2.GrößeSetzen(breite: 10, höhe: 20)
        zacke3 = Dreieck()
        zacke3.FarbeSetzen(farbe: "orange")
        zacke3.GrößeSetzen(breite: 10, höhe: 20)
        zacke4 = Dreieck()
        zacke4.FarbeSetzen(farbe: "orange")
        zacke4.GrößeSetzen(breite: 10, höhe: 20)
        kreis1 = Kreis()
        kreis1.FarbeSetzen(farbe: "orange")
        kreis1.RadiusSetzen(radius: 2)
        kreis2 = Kreis()
        kreis2.FarbeSetzen(farbe: "orange")
        kreis2.RadiusSetzen(radius: 2)
        kreis3 = Kreis()
        kreis3.FarbeSetzen(farbe: "orange")
        kreis3.RadiusSetzen(radius: 2)
        kreis4 = Kreis()
        kreis4.FarbeSetzen(farbe: "orange")
        kreis4.RadiusSetzen(radius: 2)
        PositionSetzen(zeile: 0, spalte: 0)
    }
    
    /**
    Ordnet die Teile gemäß der Position an.
    */
    func Anordnen()
    {
        basis.PositionSetzen(x: x + 5, y: y + 35)
        zacke1.PositionSetzen(x: x + 10, y: y + 15)
        zacke2.PositionSetzen(x: x + 20, y: y + 15)
        zacke3.PositionSetzen(x: x + 30, y: y + 15)
        zacke4.PositionSetzen(x: x + 40, y: y + 15)
        kreis1.PositionSetzen(x: x + 10, y: y + 13)
        kreis2.PositionSetzen(x: x + 20, y: y + 13)
        kreis3.PositionSetzen(x: x + 30, y: y + 13)
        kreis4.PositionSetzen(x: x + 40, y: y + 13)
    }
    
    /**
	Setzt die Position auf dem Schachbrett
	
	Das Brett hat links oben die Koordinaten (50|50)
	- parameters:
		- zeile: Zeilennummer des Brettes (0 - 7)
		- spalte: Spaltennummer des Brettes (0 - 7)
    */
    func PositionSetzen(zeile: Int, spalte: Int)
    {
        x = 50 + spalte * 50
        y = 400 - zeile * 50
        Anordnen()
    }
    
    /**
	Steuert die Sichtbarkeit der Dame
	- parameters:
		- sichtbar: wenn wahr, wird die Dame angezeigt
    */
    func SichtbarkeitSetzen(sichtbar: Bool)
    {
        basis.SichtbarkeitSetzen(sichtbar: sichtbar)
        zacke1.SichtbarkeitSetzen(sichtbar: sichtbar)
        zacke2.SichtbarkeitSetzen(sichtbar: sichtbar)
        zacke3.SichtbarkeitSetzen(sichtbar: sichtbar)
        zacke4.SichtbarkeitSetzen(sichtbar: sichtbar)
        kreis1.SichtbarkeitSetzen(sichtbar: sichtbar)
        kreis2.SichtbarkeitSetzen(sichtbar: sichtbar)
        kreis3.SichtbarkeitSetzen(sichtbar: sichtbar)
        kreis4.SichtbarkeitSetzen(sichtbar: sichtbar)
    }
}

/**
Verwaltet das Schachbrett und die Damen
- author: Albert Wiedemann
- version: 1.0
*/
class Schachbrett
{
    /** Referenz auf die Felder des Brettes */
    private var brett: [[Rechteck]]
    
    /**
	Legt das Schachbrett und die Damen an.
    */
    init()
    {
        brett = [[Rechteck]]()
        for zeile in 0 ..< 8
        {
            brett.append([Rechteck]())
            for spalte in 0 ..< 8
            {
                brett[zeile].append(Rechteck())
                brett[zeile][spalte].GrößeSetzen(breite: 50, höhe: 50)
                brett[zeile][spalte].PositionSetzen(x: 50 + spalte * 50, y: 400 - zeile * 50)
                brett[zeile][spalte].FarbeSetzen(farbe: ((spalte + zeile) % 2 == 0 ? "schwarz" : "weiß"))
            }
        }
    }
    
    /**
	Steuert die Sichtbarkeit des Schachbretts
	- parameters:
		- sichtbar: wenn wahr, wird das Brett angezeigt
     */
    func SichtbarkeitSetzen(sichtbar: Bool)
    {
        for zeile in 0 ..< 8
        {
            for spalte in 0 ..< 8
            {
                brett[zeile][spalte].SichtbarkeitSetzen(sichtbar: sichtbar)
            }
        }
    }
}

/**
Löst das Problem der 8 Damen
- author: Albert Wiedemann
- version: 1.0
*/
class Damen
{
    private var schachbrett: [[Bool]]
    
    /**
	Legt das Schachbrett an
    */
    init()
    {
        schachbrett = [[Bool]]()
        for zeile in 0 ..< 8
        {
            schachbrett.append([Bool]())
            for _ in 0 ..< 8
            {
                schachbrett[zeile].append(false)
            }
        }
        SchrittAusführen(spalte: 0)
    }
    
    /**
	Testet, ob das angegebene Element des Schabretts durch eine der bisher aufgestellten Damen bedroht ist.
	- parameters:
		- zeile: Zeile das Feldelements
		- spalte: Spalte das Feldelements
     */
    func IstFeldBedroht(zeile: Int, spalte: Int) -> Bool
    {
        var aktspalte = spalte - 1
        while aktspalte >= 0
        {
            if schachbrett[zeile][aktspalte]
            {
                return true
            }
            aktspalte -= 1
        }
        aktspalte = spalte - 1
        var aktzeile = zeile - 1
        while (aktspalte >= 0) && (aktzeile >= 0)
        {
            if schachbrett[aktzeile][aktspalte]
            {
                return true
            }
            aktspalte -= 1
            aktzeile -= 1
        }
        aktspalte = spalte - 1
        aktzeile = zeile + 1
        while (aktspalte >= 0) && (aktzeile < schachbrett.count)
        {
            if schachbrett[aktzeile][aktspalte]
            {
                return true
            }
            aktspalte -= 1
            aktzeile += 1
        }
        return false
    }
    
    /**
	Gibt die gefundene Lösung aus.
    */
    func LösungAusgeben()
    {
        print("Lösung:");
        for spalte in 0 ..< schachbrett.count
        {
            for zeile in 0 ..< schachbrett.count
            {
                if schachbrett[zeile][spalte]
                {
                    print("\(zeile) ", separator: "", terminator: "")
                }
            }
        }
        print()
    }
    
    /**
	Macht einen Rekursionsschritt auf dem Weg zur Lösung
	- parameters:
		- spalte: die Spalte, für die eine Position der Dame gesucht wird.
     */
    func SchrittAusführen(spalte: Int)
    {
        // Ergänzen Sie hier den Rumpf der Methode
    }
}

Damen()
