/**
Lösung für das klassische Rucksackproblem

- author: Albert Wiedemann
- version: 1.0
*/
class Rucksack
{
    /** Feld der Gewichte der Vorräte. */
    private let gewichte: [Int]
    /** Feld der Nährwerte der Vorräte */
    private let nährwerte: [Int]
    /** Feld der Nummern der aktuellen Vorräte */
    private var aktuelleVorräte: [Int]
    /** Feld der Nummern der optimalen Vorräte */
    private var optimaleVorräte: [Int]
    /** Optimaler Nährwert */
    private var optimalerNährwert: Int
    /** Maximales Gewicht im Rucksack */
    private let maximalGewicht: Int
    
    /**
	Legt die Vorratsdaten und die Attribute an.
    */
    init()
    {
        maximalGewicht = 30
        gewichte = [5, 7, 4, 3, 10, 12, 13, 8]
        nährwerte = [40, 35, 12, 30, 25, 84, 78, 80]
        aktuelleVorräte = []
        optimaleVorräte = []
        optimalerNährwert = -1
        SchrittAusführen(startIndex: 0, aktuellesGewicht: 0, aktuellerNährwert: 0)
        OptimalenVorratAusgeben()
    }
    
	/**
	Speichert den aktuellen Vorrat als optimalen Vorrat.
	- parameters:
		- nährwert:: der Gesamtnährwert des gespeicherten Vorrats.
    */
    private func OptimumSichern(nährwert: Int)
    {
        optimaleVorräte = aktuelleVorräte
        optimalerNährwert = nährwert
    }
    
	/**
	Gibt den optimalen Vorrakt auf die Konsole aus.
	*/
    func OptimalenVorratAusgeben()
    {
        print("Der optimale Vorrat hat den Gesamtnährwert \(optimalerNährwert)MJ")
        print("Einzelvorräte")
        for i in optimaleVorräte
        {
            print("Nummer \(i): Gewicht \(gewichte[i])kg, Nährwert: \(nährwerte[i])MJ")
        }
    }
    
	/**
	Fügt den nächsten Vorrat zu den bisherigen Vorräten hinzu
	- parameters:
		- startIndex: der Index, ab dem die Vorräte ergänzt werden können.
		- aktuellesGewicht: das Gewicht des bisherigen Vorratsstapels
		- aktuellerNährwert: der Nährwert des bisherigen Vorratsstapels
    */
    private func SchrittAusführen(startIndex: Int, aktuellesGewicht: Int, aktuellerNährwert: Int)
    {
        //Rumpf gemäß Aufgabenstellung ergänzen
    }
}

Rucksack()
